# decl

# Purpose

These tools work with YAML descriptions of resources (E.g. files, users, containers, etc) for (de)serializing the state of the given resource.  This enables more generically describing the state of a supported resource type, pipeling state transformations and enabling the use of other tools in that process.

# Dependencies

* Go >= 1.21.1

# Testing

Testing the current version involves checking out main and building.

```
git clone https://gitea.rosskeen.house/Declarative/decl.git

make test

make build
```

# Command-line

# Update Resource state

`cli -resource-file decl-runner.yaml`

# Read resource state

Read the state of an existing resource (URI) and generate a YAML representation of it.

![Import Resource](md-images/import-resource.gif)

# Examples

Resources:

* [file](examples/file.yaml)
* [user](examples/user.yaml)
* [container](examples/container.yaml)
